Index: NEMO/branches/2020/dev_14237_KERNEL-01_IMMERSE_SEAMOUNT/src/OCE/LBC/lib_mpp.F90
===================================================================
--- NEMO/branches/2020/dev_14237_KERNEL-01_IMMERSE_SEAMOUNT/src/OCE/LBC/lib_mpp.F90	(revision 14675)
+++ NEMO/branches/2020/dev_14237_KERNEL-01_IMMERSE_SEAMOUNT/src/OCE/LBC/lib_mpp.F90	(revision 14676)
@@ -55,4 +55,7 @@
    USE dom_oce        ! ocean space and time domain
    USE in_out_manager ! I/O manager
+#if ! defined key_mpi_off
+   USE MPI
+#endif
 
    IMPLICIT NONE
@@ -107,11 +110,16 @@
    END INTERFACE
 
+   TYPE, PUBLIC ::   PTR_4D_sp   !: array of 4D pointers (used in lbclnk and lbcnfd)
+      REAL(sp), DIMENSION (:,:,:,:), POINTER ::   pt4d
+   END TYPE PTR_4D_sp
+
+   TYPE, PUBLIC ::   PTR_4D_dp   !: array of 4D pointers (used in lbclnk and lbcnfd)
+      REAL(dp), DIMENSION (:,:,:,:), POINTER ::   pt4d
+   END TYPE PTR_4D_dp
+
    !! ========================= !!
    !!  MPI  variable definition !!
    !! ========================= !!
 #if ! defined key_mpi_off
-!$AGRIF_DO_NOT_TREAT
-   INCLUDE 'mpif.h'
-!$AGRIF_END_DO_NOT_TREAT
    LOGICAL, PUBLIC, PARAMETER ::   lk_mpp = .TRUE.    !: mpp flag
 #else
@@ -130,14 +138,31 @@
    INTEGER :: MPI_SUMDD
 
+   ! Neighbourgs informations
+   INTEGER,    PARAMETER, PUBLIC ::   n_hlsmax = 3
+   INTEGER, DIMENSION(         8), PUBLIC ::   mpinei      !: 8-neighbourg MPI indexes (starting at 0, -1 if no neighbourg)
+   INTEGER, DIMENSION(n_hlsmax,8), PUBLIC ::   mpiSnei     !: 8-neighbourg Send MPI indexes (starting at 0, -1 if no neighbourg)
+   INTEGER, DIMENSION(n_hlsmax,8), PUBLIC ::   mpiRnei     !: 8-neighbourg Recv MPI indexes (starting at 0, -1 if no neighbourg)
+   INTEGER,    PARAMETER, PUBLIC ::   jpwe = 1   !: WEst
+   INTEGER,    PARAMETER, PUBLIC ::   jpea = 2   !: EAst
+   INTEGER,    PARAMETER, PUBLIC ::   jpso = 3   !: SOuth
+   INTEGER,    PARAMETER, PUBLIC ::   jpno = 4   !: NOrth
+   INTEGER,    PARAMETER, PUBLIC ::   jpsw = 5   !: South-West
+   INTEGER,    PARAMETER, PUBLIC ::   jpse = 6   !: South-East
+   INTEGER,    PARAMETER, PUBLIC ::   jpnw = 7   !: North-West
+   INTEGER,    PARAMETER, PUBLIC ::   jpne = 8   !: North-East
+
+   LOGICAL, DIMENSION(8), PUBLIC ::   l_SelfPerio  !   should we explicitely take care of I/J periodicity
+   LOGICAL,               PUBLIC ::   l_IdoNFold
+
    ! variables used for zonal integration
-   INTEGER, PUBLIC ::   ncomm_znl       !: communicator made by the processors on the same zonal average
-   LOGICAL, PUBLIC ::   l_znl_root      !: True on the 'left'most processor on the same row
-   INTEGER         ::   ngrp_znl        !  group ID for the znl processors
-   INTEGER         ::   ndim_rank_znl   !  number of processors on the same zonal average
+   INTEGER, PUBLIC ::   ncomm_znl         !: communicator made by the processors on the same zonal average
+   LOGICAL, PUBLIC ::   l_znl_root        !: True on the 'left'most processor on the same row
+   INTEGER         ::   ngrp_znl          !: group ID for the znl processors
+   INTEGER         ::   ndim_rank_znl     !: number of processors on the same zonal average
    INTEGER, DIMENSION(:), ALLOCATABLE, SAVE ::   nrank_znl  ! dimension ndim_rank_znl, number of the procs into the same znl domain
 
    ! variables used for MPI3 neighbourhood collectives
-   INTEGER, PUBLIC :: mpi_nc_com                   ! MPI3 neighbourhood collectives communicator
-   INTEGER, PUBLIC :: mpi_nc_all_com               ! MPI3 neighbourhood collectives communicator (with diagionals)
+   INTEGER, DIMENSION(n_hlsmax), PUBLIC ::   mpi_nc_com4       ! MPI3 neighbourhood collectives communicator
+   INTEGER, DIMENSION(n_hlsmax), PUBLIC ::   mpi_nc_com8       ! MPI3 neighbourhood collectives communicator (with diagionals)
 
    ! North fold condition in mpp_mpi with jpni > 1 (PUBLIC for TAM)
@@ -185,5 +210,11 @@
 
    LOGICAL, PUBLIC ::   ln_nnogather                !: namelist control of northfold comms
-   LOGICAL, PUBLIC ::   l_north_nogather = .FALSE.  !: internal control of northfold comms
+   INTEGER, PUBLIC ::   nn_comm                     !: namelist control of comms
+
+   INTEGER, PUBLIC, PARAMETER ::   jpfillnothing = 1
+   INTEGER, PUBLIC, PARAMETER ::   jpfillcst     = 2
+   INTEGER, PUBLIC, PARAMETER ::   jpfillcopy    = 3
+   INTEGER, PUBLIC, PARAMETER ::   jpfillperio   = 4
+   INTEGER, PUBLIC, PARAMETER ::   jpfillmpi     = 5
 
    !! * Substitutions
@@ -263,5 +294,5 @@
       INTEGER , INTENT(in   ) ::   kdest      ! receive process number
       INTEGER , INTENT(in   ) ::   ktyp       ! tag of the message
-      INTEGER , INTENT(in   ) ::   md_req     ! argument for isend
+      INTEGER , INTENT(inout) ::   md_req     ! argument for isend
       !!
       INTEGER ::   iflag
@@ -292,5 +323,5 @@
       INTEGER , INTENT(in   ) ::   kdest      ! receive process number
       INTEGER , INTENT(in   ) ::   ktyp       ! tag of the message
-      INTEGER , INTENT(in   ) ::   md_req     ! argument for isend
+      INTEGER , INTENT(inout) ::   md_req     ! argument for isend
       !!
       INTEGER ::   iflag
@@ -315,5 +346,5 @@
       INTEGER , INTENT(in   ) ::   kdest      ! receive process number
       INTEGER , INTENT(in   ) ::   ktyp       ! tag of the message
-      INTEGER , INTENT(in   ) ::   md_req     ! argument for isend
+      INTEGER , INTENT(inout) ::   md_req     ! argument for isend
       !!
       INTEGER ::   iflag
@@ -942,5 +973,5 @@
       LOGICAL, OPTIONAL, INTENT(in) :: ld_abort    ! source process number
       LOGICAL ::   ll_abort
-      INTEGER ::   info
+      INTEGER ::   info, ierr
       !!----------------------------------------------------------------------
       ll_abort = .FALSE.
@@ -949,5 +980,5 @@
 #if ! defined key_mpi_off
       IF(ll_abort) THEN
-         CALL mpi_abort( MPI_COMM_WORLD )
+         CALL mpi_abort( MPI_COMM_WORLD, 123, info )
       ELSE
          CALL mppsync
@@ -962,5 +993,5 @@
    SUBROUTINE mpp_comm_free( kcom )
       !!----------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   kcom
+      INTEGER, INTENT(inout) ::   kcom
       !!
       INTEGER :: ierr
@@ -1071,5 +1102,6 @@
    END SUBROUTINE mpp_ini_znl
 
-   SUBROUTINE mpp_ini_nc
+   
+   SUBROUTINE mpp_ini_nc( khls )
       !!----------------------------------------------------------------------
       !!               ***  routine mpp_ini_nc  ***
@@ -1082,139 +1114,36 @@
       !
       !! ** output
-      !!         mpi_nc_com = MPI3 neighbourhood collectives communicator
-      !!         mpi_nc_all_com = MPI3 neighbourhood collectives communicator
-      !!                          (with diagonals)
-      !!
-      !!----------------------------------------------------------------------
-      INTEGER, DIMENSION(:), ALLOCATABLE :: ineigh, ineighalls, ineighallr
-      INTEGER :: ideg, idegalls, idegallr, icont, icont1
-      INTEGER :: ierr
-      LOGICAL, PARAMETER :: ireord = .FALSE.
-
-#if ! defined key_mpi_off
-
-      ideg = 0
-      idegalls = 0
-      idegallr = 0
-      icont = 0
-      icont1 = 0
-
-      IF (nbondi .eq. 1) THEN
-         ideg = ideg + 1
-      ELSEIF (nbondi .eq. -1) THEN
-         ideg = ideg + 1
-      ELSEIF (nbondi .eq. 0) THEN
-         ideg = ideg + 2
-      ENDIF
-
-      IF (nbondj .eq. 1) THEN
-         ideg = ideg + 1
-      ELSEIF (nbondj .eq. -1) THEN
-         ideg = ideg + 1
-      ELSEIF (nbondj .eq. 0) THEN
-         ideg = ideg + 2
-      ENDIF
-
-      idegalls = ideg
-      idegallr = ideg
-
-      IF (nones .ne. -1) idegalls = idegalls + 1
-      IF (nonws .ne. -1) idegalls = idegalls + 1
-      IF (noses .ne. -1) idegalls = idegalls + 1
-      IF (nosws .ne. -1) idegalls = idegalls + 1
-      IF (noner .ne. -1) idegallr = idegallr + 1
-      IF (nonwr .ne. -1) idegallr = idegallr + 1
-      IF (noser .ne. -1) idegallr = idegallr + 1
-      IF (noswr .ne. -1) idegallr = idegallr + 1
-
-      ALLOCATE(ineigh(ideg))
-      ALLOCATE(ineighalls(idegalls))
-      ALLOCATE(ineighallr(idegallr))
-
-      IF (nbondi .eq. 1) THEN
-         icont = icont + 1
-         ineigh(icont) = nowe
-         ineighalls(icont) = nowe
-         ineighallr(icont) = nowe
-      ELSEIF (nbondi .eq. -1) THEN
-         icont = icont + 1
-         ineigh(icont) = noea
-         ineighalls(icont) = noea
-         ineighallr(icont) = noea
-      ELSEIF (nbondi .eq. 0) THEN
-         icont = icont + 1
-         ineigh(icont) = nowe
-         ineighalls(icont) = nowe
-         ineighallr(icont) = nowe
-         icont = icont + 1
-         ineigh(icont) = noea
-         ineighalls(icont) = noea
-         ineighallr(icont) = noea
-      ENDIF
-
-      IF (nbondj .eq. 1) THEN
-         icont = icont + 1
-         ineigh(icont) = noso
-         ineighalls(icont) = noso
-         ineighallr(icont) = noso
-      ELSEIF (nbondj .eq. -1) THEN
-         icont = icont + 1
-         ineigh(icont) = nono
-         ineighalls(icont) = nono
-         ineighallr(icont) = nono
-      ELSEIF (nbondj .eq. 0) THEN
-         icont = icont + 1
-         ineigh(icont) = noso
-         ineighalls(icont) = noso
-         ineighallr(icont) = noso
-         icont = icont + 1
-         ineigh(icont) = nono
-         ineighalls(icont) = nono
-         ineighallr(icont) = nono
-      ENDIF
-
-      icont1 = icont
-      IF (nosws .ne. -1) THEN
-         icont = icont + 1
-         ineighalls(icont) = nosws
-      ENDIF
-      IF (noses .ne. -1) THEN
-         icont = icont + 1
-         ineighalls(icont) = noses
-      ENDIF
-      IF (nonws .ne. -1) THEN
-         icont = icont + 1
-         ineighalls(icont) = nonws
-      ENDIF
-      IF (nones .ne. -1) THEN
-         icont = icont + 1
-         ineighalls(icont) = nones
-      ENDIF
-      IF (noswr .ne. -1) THEN
-         icont1 = icont1 + 1
-         ineighallr(icont1) = noswr
-      ENDIF
-      IF (noser .ne. -1) THEN
-         icont1 = icont1 + 1
-         ineighallr(icont1) = noser
-      ENDIF
-      IF (nonwr .ne. -1) THEN
-         icont1 = icont1 + 1
-         ineighallr(icont1) = nonwr
-      ENDIF
-      IF (noner .ne. -1) THEN
-         icont1 = icont1 + 1
-         ineighallr(icont1) = noner
-      ENDIF
-
-      CALL MPI_Dist_graph_create_adjacent(mpi_comm_oce, ideg, ineigh, MPI_UNWEIGHTED, ideg, ineigh, MPI_UNWEIGHTED, MPI_INFO_NULL, ireord, mpi_nc_com, ierr)
-      CALL MPI_Dist_graph_create_adjacent(mpi_comm_oce, idegallr, ineighallr, MPI_UNWEIGHTED, idegalls, ineighalls, MPI_UNWEIGHTED, MPI_INFO_NULL, ireord, mpi_nc_all_com, ierr)
-
-      DEALLOCATE (ineigh)
-      DEALLOCATE (ineighalls)
-      DEALLOCATE (ineighallr)
+      !!         mpi_nc_com4 = MPI3 neighbourhood collectives communicator
+      !!         mpi_nc_com8 = MPI3 neighbourhood collectives communicator (with diagonals)
+      !!----------------------------------------------------------------------
+      INTEGER,             INTENT(in   ) ::   khls        ! halo size, default = nn_hls
+      !
+      INTEGER, DIMENSION(:), ALLOCATABLE :: iSnei4, iRnei4, iSnei8, iRnei8
+      INTEGER                            :: iScnt4, iRcnt4, iScnt8, iRcnt8
+      INTEGER                            :: ierr
+      LOGICAL, PARAMETER                 :: ireord = .FALSE.
+      !!----------------------------------------------------------------------
+#if ! defined key_mpi_off && ! defined key_mpi2
+      
+      iScnt4 = COUNT( mpiSnei(khls,1:4) >= 0 )
+      iRcnt4 = COUNT( mpiRnei(khls,1:4) >= 0 )
+      iScnt8 = COUNT( mpiSnei(khls,1:8) >= 0 )
+      iRcnt8 = COUNT( mpiRnei(khls,1:8) >= 0 )
+
+      ALLOCATE( iSnei4(iScnt4), iRnei4(iRcnt4), iSnei8(iScnt8), iRnei8(iRcnt8) )   ! ok if icnt4 or icnt8 = 0
+
+      iSnei4 = PACK( mpiSnei(khls,1:4), mask = mpiSnei(khls,1:4) >= 0 )
+      iRnei4 = PACK( mpiRnei(khls,1:4), mask = mpiRnei(khls,1:4) >= 0 )
+      iSnei8 = PACK( mpiSnei(khls,1:8), mask = mpiSnei(khls,1:8) >= 0 )
+      iRnei8 = PACK( mpiRnei(khls,1:8), mask = mpiRnei(khls,1:8) >= 0 )
+
+      CALL MPI_Dist_graph_create_adjacent( mpi_comm_oce, iScnt4, iSnei4, MPI_UNWEIGHTED, iRcnt4, iRnei4, MPI_UNWEIGHTED,   &
+         &                                 MPI_INFO_NULL, ireord, mpi_nc_com4(khls), ierr )
+      CALL MPI_Dist_graph_create_adjacent( mpi_comm_oce, iScnt8, iSnei8, MPI_UNWEIGHTED, iRcnt8, iRnei8, MPI_UNWEIGHTED,   &
+         &                                 MPI_INFO_NULL, ireord, mpi_nc_com8(khls), ierr)
+
+      DEALLOCATE( iSnei4, iRnei4, iSnei8, iRnei8 )
 #endif
    END SUBROUTINE mpp_ini_nc
-
 
 
@@ -1232,5 +1161,4 @@
       !!
       !! ** output
-      !!      njmppmax = njmpp for northern procs
       !!      ndim_rank_north = number of processors in the northern line
       !!      nrank_north (ndim_rank_north) = number  of the northern procs.
@@ -1247,5 +1175,4 @@
       !
 #if ! defined key_mpi_off
-      njmppmax = MAXVAL( njmppt )
       !
       ! Look for how many procs on the northern boundary
@@ -1398,5 +1325,5 @@
          END DO
          IF ( crname_lbc(n_sequence_lbc) /= 'already counted' ) THEN
-            WRITE(numcom,'(A, I4, A, A)') ' - ', 1,' times by subroutine ', TRIM(crname_lbc(ncom_rec_max))
+            WRITE(numcom,'(A, I4, A, A)') ' - ', 1,' times by subroutine ', TRIM(crname_lbc(n_sequence_lbc))
          END IF
          WRITE(numcom,*) ' '
Index: NEMO/branches/2020/dev_14237_KERNEL-01_IMMERSE_SEAMOUNT/src/OCE/LBC/mpp_lbc_north_icb_generic.h90
===================================================================
--- NEMO/branches/2020/dev_14237_KERNEL-01_IMMERSE_SEAMOUNT/src/OCE/LBC/mpp_lbc_north_icb_generic.h90	(revision 14675)
+++ NEMO/branches/2020/dev_14237_KERNEL-01_IMMERSE_SEAMOUNT/src/OCE/LBC/mpp_lbc_north_icb_generic.h90	(revision 14676)
@@ -31,5 +31,5 @@
       CHARACTER(len=1)        , INTENT(in   ) ::   cd_type  ! nature of pt3d grid-points
       !                                                     !   = T ,  U , V , F or W -points
-      REAL(wp)                , INTENT(in   ) ::   psgn     ! = -1. the sign change across the
+      REAL(PRECISION)         , INTENT(in   ) ::   psgn     ! = -1. the sign change across the
       !!                                                    ! north fold, =  1. otherwise
       INTEGER                 , INTENT(in   ) ::   kextj    ! Extra halo width at north fold
Index: NEMO/branches/2020/dev_14237_KERNEL-01_IMMERSE_SEAMOUNT/src/OCE/LBC/mpp_lnk_icb_generic.h90
===================================================================
--- NEMO/branches/2020/dev_14237_KERNEL-01_IMMERSE_SEAMOUNT/src/OCE/LBC/mpp_lnk_icb_generic.h90	(revision 14675)
+++ NEMO/branches/2020/dev_14237_KERNEL-01_IMMERSE_SEAMOUNT/src/OCE/LBC/mpp_lnk_icb_generic.h90	(revision 14676)
@@ -24,17 +24,12 @@
       !!                    jpi    : first dimension of the local subdomain
       !!                    jpj    : second dimension of the local subdomain
+      !!                    mpinei : number of neighboring domains (starting at 0, -1 if no neighbourg)
       !!                    kexti  : number of columns for extra outer halo
       !!                    kextj  : number of rows for extra outer halo
-      !!                    nbondi : mark for "east-west local boundary"
-      !!                    nbondj : mark for "north-south local boundary"
-      !!                    noea   : number for local neighboring processors
-      !!                    nowe   : number for local neighboring processors
-      !!                    noso   : number for local neighboring processors
-      !!                    nono   : number for local neighboring processors
       !!----------------------------------------------------------------------
       CHARACTER(len=*)                                        , INTENT(in   ) ::   cdname      ! name of the calling subroutine
       REAL(PRECISION), DIMENSION(1-kexti:jpi+kexti,1-kextj:jpj+kextj), INTENT(inout) ::   pt2d     ! 2D array with extra halo
       CHARACTER(len=1)                                        , INTENT(in   ) ::   cd_type  ! nature of ptab array grid-points
-      REAL(wp)                                                , INTENT(in   ) ::   psgn     ! sign used across the north fold
+      REAL(PRECISION)                                         , INTENT(in   ) ::   psgn     ! sign used across the north fold
       INTEGER                                                 , INTENT(in   ) ::   kexti    ! extra i-halo width
       INTEGER                                                 , INTENT(in   ) ::   kextj    ! extra j-halo width
@@ -90,5 +85,5 @@
       ! north fold treatment
       ! -----------------------
-      IF( npolj /= 0 ) THEN
+      IF( l_IdoNFold ) THEN
          !
          SELECT CASE ( jpni )
@@ -103,6 +98,5 @@
       ! we play with the neigbours AND the row number because of the periodicity
       !
-      SELECT CASE ( nbondi )      ! Read Dirichlet lateral conditions
-      CASE ( -1, 0, 1 )                ! all exept 2 (i.e. close case)
+      IF( mpinei(jpwe) >= 0 .OR. mpinei(jpea) >= 0 ) THEN   ! Read Dirichlet lateral conditions: all exept 2 (i.e. close case)
          iihom = jpi - (2 * nn_hls) -kexti
          DO jl = 1, ipreci
@@ -110,5 +104,5 @@
             r2dwe(:,jl,1) = pt2d(iihom +jl,:)
          END DO
-      END SELECT
+      ENDIF
       !
       !                           ! Migrations
@@ -120,21 +114,10 @@
       IF( ln_timing ) CALL tic_tac(.TRUE.)
       !
-      SELECT CASE ( nbondi )
-      CASE ( -1 )
-         CALL SENDROUTINE( 2, r2dwe(1-kextj,1,1), imigr, noea, ml_req1 )
-         CALL RECVROUTINE( 1, r2dew(1-kextj,1,2), imigr, noea )
-         CALL mpi_wait(ml_req1,ml_stat,ml_err)
-      CASE ( 0 )
-         CALL SENDROUTINE( 1, r2dew(1-kextj,1,1), imigr, nowe, ml_req1 )
-         CALL SENDROUTINE( 2, r2dwe(1-kextj,1,1), imigr, noea, ml_req2 )
-         CALL RECVROUTINE( 1, r2dew(1-kextj,1,2), imigr, noea )
-         CALL RECVROUTINE( 2, r2dwe(1-kextj,1,2), imigr, nowe )
-         CALL mpi_wait(ml_req1,ml_stat,ml_err)
-         CALL mpi_wait(ml_req2,ml_stat,ml_err)
-      CASE ( 1 )
-         CALL SENDROUTINE( 1, r2dew(1-kextj,1,1), imigr, nowe, ml_req1 )
-         CALL RECVROUTINE( 2, r2dwe(1-kextj,1,2), imigr, nowe )
-         CALL mpi_wait(ml_req1,ml_stat,ml_err)
-      END SELECT
+      IF( mpinei(jpwe) >= 0  )   CALL SENDROUTINE( 1, r2dew(1-kextj,1,1), imigr, mpinei(jpwe), ml_req1 )
+      IF( mpinei(jpea) >= 0  )   CALL SENDROUTINE( 2, r2dwe(1-kextj,1,1), imigr, mpinei(jpea), ml_req2 )
+      IF( mpinei(jpwe) >= 0  )   CALL RECVROUTINE( 2, r2dwe(1-kextj,1,2), imigr, mpinei(jpwe) )
+      IF( mpinei(jpea) >= 0  )   CALL RECVROUTINE( 1, r2dew(1-kextj,1,2), imigr, mpinei(jpea) )
+      IF( mpinei(jpwe) >= 0  )   CALL mpi_wait(ml_req1,ml_stat,ml_err)
+      IF( mpinei(jpea) >= 0  )   CALL mpi_wait(ml_req2,ml_stat,ml_err)
       !
       IF( ln_timing ) CALL tic_tac(.FALSE.)
@@ -142,21 +125,14 @@
       !                           ! Write Dirichlet lateral conditions
       iihom = jpi - nn_hls
-      !
-      SELECT CASE ( nbondi )
-      CASE ( -1 )
+      IF( mpinei(jpwe) >= 0  ) THEN
+         DO jl = 1, ipreci
+            pt2d(jl-kexti,:) = r2dwe(:,jl,2)
+         END DO
+      ENDIF
+      IF( mpinei(jpea) >= 0  ) THEN
          DO jl = 1, ipreci
             pt2d(iihom+jl,:) = r2dew(:,jl,2)
          END DO
-      CASE ( 0 )
-         DO jl = 1, ipreci
-            pt2d(jl-kexti,:) = r2dwe(:,jl,2)
-            pt2d(iihom+jl,:) = r2dew(:,jl,2)
-         END DO
-      CASE ( 1 )
-         DO jl = 1, ipreci
-            pt2d(jl-kexti,:) = r2dwe(:,jl,2)
-         END DO
-      END SELECT
-
+      ENDIF
 
       ! 3. North and south directions
@@ -164,5 +140,5 @@
       ! always closed : we play only with the neigbours
       !
-      IF( nbondj /= 2 ) THEN      ! Read Dirichlet lateral conditions
+      IF( mpinei(jpso) >= 0 .OR. mpinei(jpno) >= 0 ) THEN   ! Read Dirichlet lateral conditions: all exept 2 (i.e. close case)
          ijhom = jpj - (2 * nn_hls) - kextj
          DO jl = 1, iprecj
@@ -177,21 +153,10 @@
       IF( ln_timing ) CALL tic_tac(.TRUE.)
       !
-      SELECT CASE ( nbondj )
-      CASE ( -1 )
-         CALL SENDROUTINE( 4, r2dsn(1-kexti,1,1), imigr, nono, ml_req1 )
-         CALL RECVROUTINE( 3, r2dns(1-kexti,1,2), imigr, nono )
-         CALL mpi_wait(ml_req1,ml_stat,ml_err)
-      CASE ( 0 )
-         CALL SENDROUTINE( 3, r2dns(1-kexti,1,1), imigr, noso, ml_req1 )
-         CALL SENDROUTINE( 4, r2dsn(1-kexti,1,1), imigr, nono, ml_req2 )
-         CALL RECVROUTINE( 3, r2dns(1-kexti,1,2), imigr, nono )
-         CALL RECVROUTINE( 4, r2dsn(1-kexti,1,2), imigr, noso )
-         CALL mpi_wait(ml_req1,ml_stat,ml_err)
-         CALL mpi_wait(ml_req2,ml_stat,ml_err)
-      CASE ( 1 )
-         CALL SENDROUTINE( 3, r2dns(1-kexti,1,1), imigr, noso, ml_req1 )
-         CALL RECVROUTINE( 4, r2dsn(1-kexti,1,2), imigr, noso )
-         CALL mpi_wait(ml_req1,ml_stat,ml_err)
-      END SELECT
+      IF( mpinei(jpso) >= 0  )   CALL SENDROUTINE( 3, r2dns(1-kexti,1,1), imigr, mpinei(jpso), ml_req1 )
+      IF( mpinei(jpno) >= 0  )   CALL SENDROUTINE( 4, r2dsn(1-kexti,1,1), imigr, mpinei(jpno), ml_req2 )
+      IF( mpinei(jpso) >= 0  )   CALL RECVROUTINE( 4, r2dsn(1-kexti,1,2), imigr, mpinei(jpso) )
+      IF( mpinei(jpno) >= 0  )   CALL RECVROUTINE( 3, r2dns(1-kexti,1,2), imigr, mpinei(jpno) )
+      IF( mpinei(jpso) >= 0  )   CALL mpi_wait(ml_req1,ml_stat,ml_err)
+      IF( mpinei(jpno) >= 0  )   CALL mpi_wait(ml_req2,ml_stat,ml_err)
       !
       IF( ln_timing ) CALL tic_tac(.FALSE.)
@@ -200,19 +165,14 @@
       ijhom = jpj - nn_hls
       !
-      SELECT CASE ( nbondj )
-      CASE ( -1 )
-         DO jl = 1, iprecj
-            pt2d(:,ijhom+jl) = r2dns(:,jl,2)
-         END DO
-      CASE ( 0 )
-         DO jl = 1, iprecj
-            pt2d(:,jl-kextj) = r2dsn(:,jl,2)
-            pt2d(:,ijhom+jl) = r2dns(:,jl,2)
-         END DO
-      CASE ( 1 )
+      IF( mpinei(jpso) >= 0  ) THEN
          DO jl = 1, iprecj
             pt2d(:,jl-kextj) = r2dsn(:,jl,2)
          END DO
-      END SELECT
+      ENDIF
+       IF( mpinei(jpno) >= 0  ) THEN
+        DO jl = 1, iprecj
+            pt2d(:,ijhom+jl) = r2dns(:,jl,2)
+         END DO
+      ENDIF
       !
    END SUBROUTINE ROUTINE_LNK
